package com.ZepngLin.domain;

import com.ZepngLin.util.DateUtils;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.text.ParseException;
import java.util.Date;

public class Product implements Serializable {
        private String id; // 主键
        private String productNum; // 编号 唯一
        private String productName; // 名称
        private String cityName; // 出发城市
        @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
        private Date departureTime; // 出发时间
        private String departureTimeStr;
        private double productPrice; // 产品价格
        private String productDesc; // 产品描述
        private Integer productStatus; // 状态 0 关闭 1 开启
        private String productStatusStr;

    @Override
    public String toString() {
        return "Product{" +
                "id='" + id + '\'' +
                ", productNum='" + productNum + '\'' +
                ", productName='" + productName + '\'' +
                ", cityName='" + cityName + '\'' +
                ", departureTime=" + departureTime +
                ", departureTimeStr='" + departureTimeStr + '\'' +
                ", productPrice=" + productPrice +
                ", productDesc='" + productDesc + '\'' +
                ", productStatus=" + productStatus +
                ", productStatusStr='" + productStatusStr + '\'' +
                '}';
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getProductNum() {
        return productNum;
    }

    public void setProductNum(String productNum) {
        this.productNum = productNum;
    }

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getCityName() {
        return cityName;
    }

    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    public Date getDepartureTime() {
        return departureTime;
    }

    public void setDepartureTime(Date departureTime) {
        this.departureTime = departureTime;
    }

    public String getDepartureTimeStr() {
        if (departureTime != null) {
            try {
                departureTimeStr = DateUtils.dateToStr(departureTime);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        return departureTimeStr;
    }

    public void setDepartureTimeStr(String departureTimeStr) {
        this.departureTimeStr = departureTimeStr;
    }

    public double getProductPrice() {
        return productPrice;
    }

    public void setProductPrice(double productPrice) {
        this.productPrice = productPrice;
    }

    public String getProductDesc() {
        return productDesc;
    }

    public void setProductDesc(String productDesc) {
        this.productDesc = productDesc;
    }

    public Integer getProductStatus() {
        return productStatus;
    }

    public void setProductStatus(Integer productStatus) {
        this.productStatus = productStatus;
    }

    public String getProductStatusStr() {
        if (productStatus.equals(0)){
            productStatusStr = "否";
        }else productStatusStr = "是";
        return productStatusStr;
    }
    public void setProductStatusStr(String productStatusStr) {

        this.productStatusStr = productStatusStr;
    }
}
